---
layout: default
title: DevOps explained
description: "Learn all about DevOps"
suppress_header: true
extra_css:
  - devops.css
extra_js:
  - libs/on-scroll.js
  - in-page-nav.js
  - all-clickable.js
canonical_path: "/devops/"
---
.blank-header
  %img.image-border.image-border-left{ src: "/images/home/icons-pattern-left.svg", alt: "Gitlab hero border pattern left svg" }
  %img.image-border.image-border-right{ src: "/images/home/icons-pattern-right.svg", alt: "Gitlab hero border pattern right svg" }
  .header-content
    %img.hero-image-huge{ src: "/images/webcast/devops-loop.svg", alt: "Gitlab devops loop svg" }
    %h1 DevOps explained
    %p Learn more about concurrent devops in our latest whitepaper.
    %a.btn.cta-btn.orange.devops-cta{ href: "/resources/whitepaper-concurrent-devops/" } Download your free copy

.wrapper.wrapper--large-fonts
  #content.devops-content.u-margin-top-lg
    .wrapper.container.js-in-page-nav-group{role: "main"}
      .row.u-margin-top-lg.js-in-page-nav-section#what-is-devops
        .col-md-10.col-md-offset-1
          %h2.u-text-brand What is DevOps?

          %p DevOps can be best explained as people working together to build, deliver, and run resilient software at the speed of their particular business. DevOps enables software development (Dev) and operations (Ops) teams to accelerate delivery through automation, collaboration, fast feedback, and iterative improvement.

          %p Stemming from an Agile approach to software development, DevOps expands on the cross-functional approach of building and shipping applications in a faster and more iterative manner. In adopting DevOps, one is making a decision to improve the flow and value delivery of their application by encouraging a more collaborative environment at all stages of the development cycle.

          %blockquote.blockquote-alt
            %b DevOps
            is a combination of software development (Dev) and operations (Ops). It is defined as a software engineering methodology which aims to integrate the work of software development and software operations teams by facilitating a culture of collaboration and shared responsibility.

          %p DevOps represents a change in mindset for IT culture. In building on top of Agile, lean practices, and systems theory, DevOps focuses on incremental development and rapid delivery of software. Success relies on the ability to create a culture of accountability, collaboration, empathy, and joint responsibility for business outcomes.

      .row.u-margin-top-xl.js-in-page-nav-section#why-adopt-devops
        .col-md-10.col-md-offset-1
          %h2.u-text-brand{ 'data-js-in-page-nav-title' => 'Why adopt DevOps?' } Why adopt a DevOps model?

          %p Adopting a DevOps model breaks down barriers so that development and operations teams are no longer siloed and have a more efficient way to work across the entire development lifecycle. Without DevOps, organizations experience handoff friction, which delays delivery and negatively impacts business results.

          %p The DevOps model is an organization’s answer to increasing operational efficiency, accelerating delivery, and innovating products. Organizations that have implemented DevOps experience the benefits of increased collaboration, fluid responsiveness, and shorter cycle times.

      .row.u-margin-top-xl.js-in-page-nav-section#benefits-of-devops
        .col-md-10.col-md-offset-1
          %h2.u-text-brand Benefits of DevOps

          .media.u-margin-top-sm.u-margin-bottom-md.has-shadowed-svg
            .media-left.media-middle.u-padding-right-sm
              .media-object.svg-shadow{ style: "width: 162px; height: 186px" }
                = partial "includes/icons/collaboration-icon.svg"

            .media-body.media-middle
              %h3.u-margin-top-0 Collaboration

              %p.u-margin-bottom-0 Adopting a DevOps model creates alignment between development and operations teams; handoff friction is reduced and, everyone is all in on the same goals and objectives.

          .media.u-margin-top-sm.u-margin-bottom-md.has-shadowed-svg
            .media-left.media-middle.u-padding-right-sm
              .media-object.svg-shadow{ style: "width: 162px; height: 162px;" }
                = partial "includes/icons/efficiency-icon.svg"
            .media-body.media-middle
              %h3.u-margin-top-0 Fluid responsiveness

              %p.u-margin-bottom-0 More collaboration leads to real-time feedback and greater efficiency; changes and improvements can be implemented quicker and guesswork is removed.

          .media.u-margin-top-sm.u-margin-bottom-md.has-shadowed-svg
            .media-left.media-middle.u-padding-right-sm
              .media-object.svg-shadow{ style: "width: 162px; height: 162px;" }
                = partial "includes/icons/time-icon.svg"
            .media-body.media-middle
              %h3.u-margin-top-0 Shorter cycle time

              %p.u-margin-bottom-0 Improved efficiency and frequent communication between teams shortens cycle time; new code can be released more rapidly while maintaining quality and security.

      .row.u-margin-top-md.js-in-page-nav-section#devops-fundamentals
        .col-md-10.col-md-offset-1
          %h2.u-text-brand DevOps fundamentals

          %p The business value of DevOps lies in the ability to deliver software faster with continuous improvement. You need the ability to anticipate and respond to industry disruptors without delay. This becomes possible when teams are empowered to be autonomous and deliver faster, reducing work in progress. Once this occurs, teams are able to respond to demands at the speed of the market.

          %p There are some fundamental concepts that need to be put into action in order for DevOps to function as designed, including the need to:

          %ul
            %li
              Remove institutionalized silos and handoffs that lead to road blocks and constraints, particularly in instances where the measurements of success for one team is in direct odds with another team’s key performance indicators (KPIs).

              %ul.u-margin-top-xs
                %li For example, Team A is tasked with preventing outages. In order to reach that goal, they create processes that are prohibitive to rapid changes in the application’s development; thereby creating a bottleneck that negatively impacts Team B’s KPI of frequent software updates.

            %li.u-margin-top-xs Implement a unified tool chain using a single application that allows multiple teams to share and collaborate. This will enable teams to accelerate delivery and provide fast feedback to one another.

          %div.u-image-bg.u-release.u-text-light.u-margin-top-xl.u-margin-bottom-md{ style: "background-image:url('/images/scaling-devops-bg.jpg');" }
            .container
              .row.u-margin-top-lg.u-margin-bottom-lg
                .col-md-10.col-md-offset-1
                  %h2 Start your DevOps journey

                  %h3.u-margin-top-md Starting and Scaling DevOps in the Enterprise
                  %p Sharing his pioneering insight on how organizations can transform their software development and delivery processes, Gary Gruver provides a tactical framework to implement DevOps principles in “Starting and Scaling DevOps in the Enterprise.”

                  .btn-group
                    %a.btn.cta-btn.purple-reverse{ href: "/resources/scaling-enterprise-devops/" } Download your free copy

          %p
            Ok, now you know what DevOps is, but what’s next?
            %a{ href: "/concurrent-devops" } Learn about Concurrent DevOps
            or take a deeper dive with these helpful articles.

          .feature-group.feature-group--alt.u-margin-top-sm.u-margin-bottom-sm.u-padding-top-0.u-padding-bottom-0
            .row.flex-row
              .col-md-4.col-lg-4
                .feature.js-all-clickable
                  .feature-media
                    = image_tag "/images/feature-thumbs/feature-thumb-devops.png", alt: 'DevOps', srcset: "/images/feature-thumbs/feature-thumb-devops_2x.png 2x"
                  .feature-body
                    %h3.feature-title Trust, but verify: The importance of test automation
                    %p.feature-description “Trust, but verify” needs to be the motto for a good DevOps automation pipeline as well.
                    %a.feature-more{ href: "/2018/04/23/test-automation-devops/" } Read

              .col-md-4.col-lg-4
                .feature.js-all-clickable
                  .feature-media
                    = image_tag "/images/feature-thumbs/feature-thumb-how-to-create-ci-cd-pipeline-with-autodeploy-to-kubernetes-using-gitlab-and-helm.png", alt: 'Create a CI/CD pipeline blog post', srcset: "/images/feature-thumbs/feature-thumb-how-to-create-ci-cd-pipeline-with-autodeploy-to-kubernetes-using-gitlab-and-helm_2x.png 2x"
                  .feature-body
                    %h3.feature-title Avoiding the DevOps Tax
                    %p.feature-description Realize a faster DevOps lifecycle with these best practices for integration and automation.
                    %a.feature-more{ href: "/2018/03/21/avoiding-devops-tax-webcast/" } Read

              .col-md-4.col-lg-4
                .feature.js-all-clickable
                  .feature-media
                    = image_tag "/images/feature-thumbs/feature-thumb-gitlab-kubernetes.png", alt: 'GitLab & Kubernetes', srcset: "/images/feature-thumbs/feature-thumb-gitlab-kubernetes_2x.png 2x"
                  .feature-body
                    %h3.feature-title A beginners guide to continuous integration
                    %p.feature-description Here's how to help everyone on your team, like designers and testers, get started with continuous integration.
                    %a.feature-more{ href: "/2018/01/22/a-beginners-guide-to-continuous-integration/" } Read

          %p
            Looking for Auto DevOps?
            %a{:title => '', :href => 'https://docs.gitlab.com/ee/topics/autodevops/'} Go to the documentation.

      .row.u-margin-top-xl.js-in-page-nav-section#resources
        .col-md-10.col-md-offset-1
          %h2.u-text-brand Resources


          %p Here’s a list of resources on DevOps that we find to be particularly helpful in understanding DevOps and implementation. We would love to get your recommendations on books, blogs, videos, podcasts and other resources that tell a great DevOps story or offer valuable insight on the definition or implementation of the practice.

          %p
            Please share your favorites with us by tweeting us
            %a{:href => 'https://twitter.com/gitlab'} @GitLab!

          .resource-block.resource-block--books.u-margin-top-md
            %h3.block-title Books

            %ul.resource-list.list-unstyled
              %li.resource-list-item
                %h4.resource-title
                  %a{ href: "https://www.amazon.com/Leading-Transformation-Applying-DevOps-Principles/dp/1942788010" } Leading the Transformation
                %span.resource-author by Gary Gruver & Tommy Mouser

              %li.resource-list-item
                %h4.resource-title
                  %a{ href: "https://www.amazon.com/The-Goal-Process-Ongoing-Improvement/dp/0884271951/" } The Goal
                %span.resource-author by Eliyahu M. Goldratt

              %li.resource-list-item
                %h4.resource-title
                  %a{ href: "https://www.amazon.com/Start-Scaling-Devops-Enterprise-Gruver/dp/1483583589/" } Starting and Scaling DevOps in the Enterprise
                %span.resource-author by Gary Gruver

              %li.resource-list-item
                %h4.resource-title
                  %a{ href: "https://www.amazon.com/Continuous-Delivery-Deployment-Automation-Addison-Wesley/dp/0321601912" } Continuous Delivery
                %span.resource-author by Jez Humble and  David Farley (445 pages)

              %li.resource-list-item
                %h4.resource-title
                  %a{ href: "https://www.amazon.com/The-Phoenix-Project-Helping-Business/dp/0988262509/" } The Phoenix Project
                %span.resource-author by Gene Kim, Kevin Behr & George Spafford


          %hr.u-margin-top-md.u-margin-bottom-md


          .resource-block.resource-block--videos
            %h3.block-title Videos

            %ul.resource-list.list-unstyled
              %li.resource-list-item
                %h4.resource-title
                  %a{ href: "https://www.youtube.com/watch?v=LdOe18KhtT4" } 10+ Deploys per day at Flickr – Velocity 2009
                %span.resource-author with John Allspaw and Paul Hammond

              %li.resource-list-item
                %h4.resource-title
                  %a{ href: "https://www.youtube.com/watch?t=18&v=o7-IuYS0iSE" } DevOps History
                %span.resource-author by Damon Edwards

              %li.resource-list-item
                %h4.resource-title
                  %a{ href: "https://www.youtube.com/watch?v=_I94-tJlovg" } What is DevOps
                %span.resource-author by RackSpace

              %li.resource-list-item
                %h4.resource-title
                  %a{ href: "https://labs.spotify.com/2014/03/27/spotify-engineering-culture-part-1/" } Spotify Engineering Culture (part 1) & (part 2)

              %li.resource-list-item
                %h4.resource-title
                  %a{ href: "https://www.youtube.com/watch?v=WqoVeGFjK9k" } Agile and DevOps
                %span.resource-author by John Okoro

              %li.resource-list-item
                %h4.resource-title
                  %a{ href: "https://www.youtube.com/watch?v=oX8af9kLhlk" } Jez Humble @ Chef 2015
                %span.resource-author Keynote on DevOps and CD


          %hr.u-margin-top-md.u-margin-bottom-md


          .resource-block.resource-block--blogs
            %h3.block-title Blogs

            %ul.resource-list.list-unstyled
              %li.resource-list-item
                %h4.resource-title
                  %a{ href: "https://theagileadmin.com/what-is-devops/" } What is DevOps
                %span.resource-author by The Agile Admin

              %li.resource-list-item
                %h4.resource-title
                  %a{ href: "http://www.jamesshore.com/Blog/Continuous-Integration-on-a-Dollar-a-Day.html" } Continuous Integration on a dollar a day
                %span.resource-author by James Shore


          %hr.u-margin-top-md.u-margin-bottom-md


          .resource-block.resource-block--podcasts
            %h3.block-title Podcasts

            %ul.resource-list.list-unstyled
              %li.resource-list-item
                %h4.resource-title
                  %a{ href: "http://devopscafe.org/" } DevOps Cafe

              %li.resource-list-item
                %h4.resource-title
                  %a{ href: "https://www.thisamericanlife.org/403/nummi" } This American Life: Nummi

              %li.resource-list-item
                %h4.resource-title
                  %a{ href: "https://www.arresteddevops.com/" } Arrested DevOps
